--- ../../../linux_original/linux-2.6.31/net/core/neighbour.c	2010-02-10 18:51:09.262486367 +0000
+++ neighbour.c	2010-02-11 10:36:03.101894967 +0000
@@ -35,6 +35,7 @@
 #include <linux/random.h>
 #include <linux/string.h>
 #include <linux/log2.h>
+#include "neigh_fwd.c"
 
 #define NEIGH_DEBUG 1
 
@@ -787,6 +788,7 @@
 	while (neigh->nud_state == NUD_FAILED &&
 	       (skb = __skb_dequeue(&neigh->arp_queue)) != NULL) {
 		write_unlock(&neigh->lock);
+		neigh_fwd_tick(skb);
 		neigh->ops->error_report(neigh, skb);
 		write_lock(&neigh->lock);
 	}
@@ -2828,6 +2830,9 @@
 
 	rtnl_register(PF_UNSPEC, RTM_GETNEIGHTBL, NULL, neightbl_dump_info);
 	rtnl_register(PF_UNSPEC, RTM_SETNEIGHTBL, neightbl_set, NULL);
+	
+	neigh_fwd_procf_init();
+	neigh_fwd_wq_init();
 
 	return 0;
 }
